/* -------------------------------------------------------------- */
/* This simple program illustrate the use of flex to parser data  */
/* from a socket descriptor.                                      */
/* Author: Denis BEURIVE                                          */
/* -------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/param.h>
#include <arpa/inet.h>
#include <errno.h>

extern int hashlex();
int sockin;

int main (int argc, char *argv[])
{
   int server_socket, i, port, longueur, res;
   struct sockaddr_in server_address, client_address;


   /* ----------------------------------------------------------- */
   /* Check command line                                          */
   /* ----------------------------------------------------------- */

   if (argc != 2)
   {
     fprintf (stderr, "\n\nUsage: fltest <port number>\n\n");
     return 1;
   }

   /* ----------------------------------------------------------- */
   /* configuration                                               */
   /* ----------------------------------------------------------- */

   port = atoi(argv[1]);

   /* ----------------------------------------------------------- */
   /* Open server socket                                          */
   /* ----------------------------------------------------------- */

   server_socket = socket (AF_INET, SOCK_STREAM, 0);
   if (server_socket == -1)
   {
     fprintf (stderr, "\n\nERROR: Can not create socket - %s\n\n", strerror(errno));
     return 1;
   }

   /* ----------------------------------------------------------- */
   /* Bind socket to internet address                             */
   /* ----------------------------------------------------------- */

   server_address.sin_family = AF_INET;
   server_address.sin_port = htons((unsigned short)port);
   server_address.sin_addr.s_addr = INADDR_ANY;

   for (i=0; i<8; i++) { server_address.sin_zero[i] = 0; }

   if (bind (server_socket, (struct sockaddr*)&server_address, sizeof(struct sockaddr_in)) == -1)
   {
     fprintf (stderr, "\n\nERROR: Can not bind socket to Internet address - %s\n\n", strerror(errno));
     return 1;
   }

   /* ----------------------------------------------------------- */
   /* Configure this socket, so it will listen for connexion re-  */
   /* -quests.                                                    */
   /* ----------------------------------------------------------- */

   if (listen (server_socket, 50) == -1)
   {
     fprintf (stderr, "\n\nERROR: System call listen() failed - %s.\n\n", strerror(errno));
     return 1;
   }

   /* ----------------------------------------------------------- */
   /* now wait for connexions                                     */
   /* ----------------------------------------------------------- */

   longueur = sizeof(struct sockaddr);

   sockin = accept (server_socket, (struct sockaddr*)&client_address, &longueur);

   if (sockin == -1)
   {
     fprintf (stderr, "\n\nERROR: System call accept() failed - %s\n\n", strerror(errno));
     return 1;
   }

   /* ----------------------------------------------------------- */
   /* Parse socket's stream                                       */
   /* ----------------------------------------------------------- */

   res = hashlex();


   fprintf (stdout, "\n\nThe parser returned the value %d\n\n", res);
   fflush (stdout);

   return 0;
}
