%{

/* Author: Denis BEURIVE */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int hashwrap() { return 1; }

/* ------------------------------------------------ */
/* This global variable represents the socket des-  */
/* -criptor used by the parser as input.            */
/* ------------------------------------------------ */

extern int sockin;

/* ------------------------------------------------ */
/* Instead of reading data from a file, we redefine */
/* YY_INPUT, so we read data from the socket des-   */
/* -criptor 'sockin'.                               */
/* ------------------------------------------------ */

#define YY_INPUT(buf,result,max_size) \
{ \
  size_t nb_bytes; \
                                                                   \
  nb_bytes = read(sockin, (void*)buf, (size_t)max_size); \
                                                                   \
  if ((nb_bytes == 0) || (nb_bytes == -1)) { result = YY_NULL; } \
  else { result = nb_bytes; } \
}


%}

ALPHA ([A-Z]|[a-z])
NUMERIC [0-9]
ALPHANUM ({ALPHA}|{NUMERIC})
CARACTER ({ALPHANUM}|[_\-])
TAG \{{CARACTER}+\}

%%

{TAG} {
          fprintf (stdout, "\ntag: %s", yytext);
          fflush (stdout);
        }
\n { /* Do nothing - ignore input */ }
. { /* Do nothing - ignore input */ }

%%
